


#ifndef APPLICATION_H
#define APPLICATION_H


#include <vrj/Kernel/Kernel.h>
#include <vrj/Draw/OpenGL/App.h>
#include <vrj/Draw/OpenGL/ContextData.h>

#include <gadget/Type/PositionInterface.h>
#include <gadget/Type/DigitalInterface.h>

#include <gmtl/gmtl.h>

#include <GL/gl.h>



class Application : public vrj::opengl::App
{
public:
	Application();
	virtual ~Application();

	virtual void init();
	virtual void exit();

	virtual void draw();

	virtual void contextInit();
	virtual void contextPreDraw();
	virtual void bufferPreDraw();

	virtual void preFrame();
	virtual void latePreFrame();

protected:
	virtual float getDrawScaleFactor();


	void DrawCross(float size);
	void DrawGrid(float size, unsigned int halfSteps);
	void DrawRay(float length);
	void DrawUnitCube();
		
	void GenerateCubeDList();
	void GenerateCheckeredTexture();
	
	void UnitCubeGeometry();
};



#endif
